//!	xiac.h
//!	XiAudioCodec Format.
//!	$Revision: $
//	@author	(C) Arle - wk
//	@note	Ql(IWi):http://kaedeps2.at.infoseek.co.jp/
//
#ifndef	__XI_AC__
#define	__XI_AC__

#pragma comment(lib, "winmm.lib")

#include <iostream>
#include <stdlib.h>
#include <windows.h>
#include <mmsystem.h>

typedef	signed char int8_t;
typedef	unsigned char uint8_t;
typedef	signed short int16_t;
typedef	unsigned short uint16_t;
typedef	signed long int32_t;
typedef	unsigned long uint32_t;
typedef	signed __int64 int64_t;
typedef	unsigned __int64 uint64_t;

#define	XI_CHANNEL_MAX		6
#define	XI_SAMPLE_MAX		100000

#pragma pack(push, 1)	//	start span. ԂȂ悤ɁB

//	XiAudioCodec Music Format Header
struct XiMusicHeader
{
	uint8_t		Magic[12];
	uint32_t	Type;
	uint32_t	Size;		
	uint32_t	Index;
	uint32_t	DataCount;
	uint32_t	LoopPos;
	int32_t		Sample1;
	int32_t		Sample2;
	uint32_t	DataOffset;
	uint8_t		Volume;
	uint8_t		BitsPerSample;
	uint8_t		Channels;
	uint8_t		SampleLength;
};

//	XiAudioCodec Sound Format Header
struct XiSoundHeader
{
	uint8_t		Magic[8];
	uint32_t	Size;
	uint32_t	Type;
	uint32_t	Index;
	uint32_t	DataCount;
	uint32_t	LoopPos;
	uint32_t	Sample1;
	uint32_t	Sample2;
	uint32_t	DataOffset;
	uint8_t		Volume;
	uint8_t		Flag;
	uint8_t		Channels;
	uint8_t		BitsPerSample;
	uint8_t		SampleLength;
	uint8_t		_Align[3];
};

#pragma pack(pop, 1)	//	-- end span.

#endif